#/bin/bash
#
# Patch generator from Files Unsharing X.Y.Z -> Files Unsharing + owncloud-addons
# Developer tool, not for end users. Part of owncloud-addons package.
# Use folder structure below:
# /root/tmp/files_unsharing-X.Y.Z-original
#          /files_unsharing-X.Y.Z-patched
#          /files_unsharing-createpatch.sh (maybe symlinked)
# Call: export PLUGIN_VERSION="X.Y.Z"; ./files_unsharing-createpatch.sh as root.

if [ -z "$PLUGIN_VERSION" ]; then echo "Set PLUGIN_VERSION variable, please!"; exit 1; fi
if [ ! -d "files_unsharing-$PLUGIN_VERSION-original" ]; then echo "Missing folder: files_unsharing-$PLUGIN_VERSION-original"; exit 1; fi
if [ ! -d "files_unsharing-$PLUGIN_VERSION-patched"  ]; then echo "Missing folder: files_unsharing-$PLUGIN_VERSION-patched";  exit 1; fi

cd files_unsharing-$PLUGIN_VERSION-original
diff -Naur -x *.gif -x *.jpg -x *.png . ../files_unsharing-$PLUGIN_VERSION-patched \
     | grep -iv ^diff >../files_unsharing_$PLUGIN_VERSION-owncloud-addons_$(date +%Y%m%d).patch
cd ..
