#/bin/bash
#
# Patch generator from Mozilla Sync Service X.Y.Z -> Mozilla Sync Service X.Y.Z + owncloud-addons
# Developer tool, not for end users. Part of owncloud-addons package.
# Use folder structure below:
# /root/tmp/mozilla_sync-X.Y.Z-original
#          /mozilla_sync-X.Y.Z-patched
#          /mozilla_sync-createpatch.sh (maybe symlinked)
# Call: export PLUGIN_VERSION="X.Y.Z"; ./mozilla_sync-createpatch.sh as root.

if [ -z "$PLUGIN_VERSION" ]; then echo "Set PLUGIN_VERSION variable, please!"; exit 1; fi
if [ ! -d "mozilla_sync-$PLUGIN_VERSION-original" ]; then echo "Missing folder: mozilla_sync-$PLUGIN_VERSION-original"; exit 1; fi
if [ ! -d "mozilla_sync-$PLUGIN_VERSION-patched"  ]; then echo "Missing folder: mozilla_sync-$PLUGIN_VERSION-patched";  exit 1; fi

cd mozilla_sync-$PLUGIN_VERSION-original
diff -Naur -x *.gif -x *.jpg -x *.png . ../mozilla_sync-$PLUGIN_VERSION-patched \
     | grep -iv ^diff >../mozilla_sync_$PLUGIN_VERSION-owncloud-addons_$(date +%Y%m%d).patch
cd ..
